/* 쌠 (C) 2012-2015 Atmel Corporation. ֓]
*
* \asf_license_start
*
* \page License
*
* ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
* ΋܂B
* 
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*    Ȃ΂Ȃ܂B
* 
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
* 
* 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*    (ۏ)ɎgpłȂ܂B
* 
* 4. ̿ĳAtmelAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
* 
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂAtmel̂悤ȑQ̉\iꂽƂĂA
* {gpłȂA܂͎gpȊOŔ(̑AƒfA܂͗v
* ̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRARAʁA܂͕t
* ċN@Ȃ鑹Qɑ΂ĂAtmelɐӔCȂł傤B
*
* \asf_license_stop
*
*/

/*============================ ݸٰ =======================================*/

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

/*============================== ` ========================================*/

uint16_t adc_results =0;

/* ̊֐ADCSĂ̎Ӌ@\ւ̸ۯ~܂B */
void disable_peripherals(void)
{
	PR.PRGEN = PR_USB_bm | PR_AES_bm | PR_EBI_bm | PR_RTC_bm | PR_EVSYS_bm | PR_DMA_bm;						// USB,AES,EBI,RTC,ۼ,DMAւ̸ۯ~
	PR.PRPA = PR_DAC_bm | PR_AC_bm;																			// DACƱ۸ޔrւ̸ۯ~
	PR.PRPB = PR_DAC_bm | PR_AC_bm;
	PR.PRPC = PR_TWI_bm | PR_USART1_bm | PR_USART0_bm | PR_SPI_bm | PR_HIRES_bm | PR_TC1_bm | PR_TC0_bm;	// 2̪,USART1,USART0,SPI,/0/1ւ̸ۯ~
	PR.PRPD = PR_TWI_bm | PR_USART1_bm | PR_USART0_bm | PR_SPI_bm | PR_HIRES_bm | PR_TC1_bm | PR_TC0_bm;
	PR.PRPE = PR_TWI_bm | PR_USART1_bm | PR_USART0_bm | PR_SPI_bm | PR_HIRES_bm | PR_TC1_bm | PR_TC0_bm;
	PR.PRPF = PR_TWI_bm | PR_USART1_bm | PR_USART0_bm | PR_SPI_bm | PR_HIRES_bm | PR_TC1_bm | PR_TC0_bm;
}

/* ̊֐JTAG̪֎~܂B */
void disable_JTAG(void)
{
	CCP = CCP_IOREG_gc;
	MCU.MCUCR = MCU_JTAGD_bm;	// JTAG֎~
}

/* ̊֐ADCs܂B */
void ADC_initialize(void)
{
	CCP = 0xD8;
	CLK.PSCTRL = CLK_PSADIV_2_gc;											// OuA͸ۯ2
	ADCA.CTRLB = ADC_CURRLIMIT_HIGH_gc;										// 12ޯADC\(E)ƍd
	ADCA.REFCTRL = ADC_REFSEL_INTVCC_gc;									// ADCdVcc/1.6ݒ
	ADCA.PRESCALER = ADC_PRESCALER_DIV4_gc;									// ADCۯFosc/4
	ADCA.CH0.CTRL = ADC_CH_INPUTMODE_SINGLEENDED_gc;						// ݸ ނƂADCّI
	ADCA.CH0.MUXCTRL = ADC_CH_MUXPOS_PIN0_gc;								// ch0PB1ɔz
	ADCA.CH0.INTCTRL = ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_HI_gc;	// ϊ荞݋ƂD抄荞݂ƂĒ`
	ADCA.CTRLA = ADC_ENABLE_bm;												// ADC
}

ISR(ADCA_CH0_vect)
{
	adc_results = ADCA_CH0RES;			// ADC
	ADCA.CH0.INTFLAGS = ADC_CH_CHIF_bm;
	ADCA.CH0.CTRL = ADC_CH_START_bm;	// ADC0ɑ΂ĕϊJn
}

int main(void)
{
	ADC_initialize();
	disable_peripherals();
	disable_JTAG();
	ADCA.CH0.CTRL = ADC_CH_START_bm;	// ADC0ɑ΂ĕϊJn
	PMIC.CTRL = PMIC_HILVLEN_bm;
	sei();
	while(1)
	{

	}
}
